curl --request POST \
--url https://api.fabric.inc/v3/orchestrator/carts/{cartId}/items \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--header 'x-fabric-channel-id: <x-fabric-channel-id>' \
--header 'x-fabric-tenant-id: <x-fabric-tenant-id>' \
--data '
{
"items": [
{
"sku": "<string>",
"quantity": 123,
"itemId": "<string>",
"priceListId": "<string>",
"price": {
"total": 1570,
"subtotal": 1530,
"tax": 0,
"fulfillments": 40,
"discounts": 0,
"fees": 0,
"adjustments": 0
},
"fulfillment": {
"id": "d6229cdb-0c5b-4885-b1b2-13b94d02488e",
"type": "SHIP_TO",
"refId": "398427903843",
"attributes": {
"source": "store"
},
"originAddress": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
"destinationAddress": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
"locationId": "CA",
"pickupPerson": {
"secondary": [
{
"name": {
"first": "John",
"last": "Doe"
},
"email": "john@test.com",
"phone": {
"number": "1234567890",
"type": "MOBILE"
}
}
]
},
"promotions": {
"total": 15,
"collection": [
{
"id": "bb44db95-6fbd-4eed-a1ed-4d99bc91250f",
"amount": 15
}
]
},
"fees": {
"total": 5,
"collection": [
{
"id": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
"name": "Eco Fee",
"taxable": true,
"attributes": {
"source": "eco"
},
"tax": {
"total": 3,
"collection": [
{
"amount": 3,
"attributes": {
"rate": "5.0",
"type": "COUNTY"
}
}
]
},
"updatedAt": "2024-06-13T16:50:00.682Z",
"createdAt": "2024-06-13T16:50:00.682Z",
"taxDetails": {
"destinationAddress": "c86f777b-1885-4ddf-961d-542ba80a69b8",
"originAddress": "c86f777b-1885-4ddf-961d-542ba80a69b8"
}
}
]
},
"adjustments": {
"total": 2,
"collection": [
{
"id": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
"reason": "Price adjustment from customer representative.",
"attributes": {
"source": "CSR"
},
"updatedAt": "2024-06-13T16:50:00.682Z",
"createdAt": "2024-06-13T16:50:00.682Z"
}
]
},
"tax": {
"total": 3,
"collection": [
{
"amount": 3,
"attributes": {
"rate": "5.0",
"type": "COUNTY"
}
}
]
}
}
}
]
}
'import requests
url = "https://api.fabric.inc/v3/orchestrator/carts/{cartId}/items"
payload = { "items": [
{
"sku": "<string>",
"quantity": 123,
"itemId": "<string>",
"priceListId": "<string>",
"price": {
"total": 1570,
"subtotal": 1530,
"tax": 0,
"fulfillments": 40,
"discounts": 0,
"fees": 0,
"adjustments": 0
},
"fulfillment": {
"id": "d6229cdb-0c5b-4885-b1b2-13b94d02488e",
"type": "SHIP_TO",
"refId": "398427903843",
"attributes": { "source": "store" },
"originAddress": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
"destinationAddress": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
"locationId": "CA",
"pickupPerson": { "secondary": [
{
"name": {
"first": "John",
"last": "Doe"
},
"email": "john@test.com",
"phone": {
"number": "1234567890",
"type": "MOBILE"
}
}
] },
"promotions": {
"total": 15,
"collection": [
{
"id": "bb44db95-6fbd-4eed-a1ed-4d99bc91250f",
"amount": 15
}
]
},
"fees": {
"total": 5,
"collection": [
{
"id": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
"name": "Eco Fee",
"taxable": True,
"attributes": { "source": "eco" },
"tax": {
"total": 3,
"collection": [
{
"amount": 3,
"attributes": {
"rate": "5.0",
"type": "COUNTY"
}
}
]
},
"updatedAt": "2024-06-13T16:50:00.682Z",
"createdAt": "2024-06-13T16:50:00.682Z",
"taxDetails": {
"destinationAddress": "c86f777b-1885-4ddf-961d-542ba80a69b8",
"originAddress": "c86f777b-1885-4ddf-961d-542ba80a69b8"
}
}
]
},
"adjustments": {
"total": 2,
"collection": [
{
"id": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
"reason": "Price adjustment from customer representative.",
"attributes": { "source": "CSR" },
"updatedAt": "2024-06-13T16:50:00.682Z",
"createdAt": "2024-06-13T16:50:00.682Z"
}
]
},
"tax": {
"total": 3,
"collection": [
{
"amount": 3,
"attributes": {
"rate": "5.0",
"type": "COUNTY"
}
}
]
}
}
}
] }
headers = {
"x-fabric-tenant-id": "<x-fabric-tenant-id>",
"x-fabric-channel-id": "<x-fabric-channel-id>",
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {
'x-fabric-tenant-id': '<x-fabric-tenant-id>',
'x-fabric-channel-id': '<x-fabric-channel-id>',
Authorization: 'Bearer <token>',
'Content-Type': 'application/json'
},
body: JSON.stringify({
items: [
{
sku: '<string>',
quantity: 123,
itemId: '<string>',
priceListId: '<string>',
price: {
total: 1570,
subtotal: 1530,
tax: 0,
fulfillments: 40,
discounts: 0,
fees: 0,
adjustments: 0
},
fulfillment: {
id: 'd6229cdb-0c5b-4885-b1b2-13b94d02488e',
type: 'SHIP_TO',
refId: '398427903843',
attributes: {source: 'store'},
originAddress: 'a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93',
destinationAddress: 'a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93',
locationId: 'CA',
pickupPerson: {
secondary: [
{
name: {first: 'John', last: 'Doe'},
email: 'john@test.com',
phone: {number: '1234567890', type: 'MOBILE'}
}
]
},
promotions: {
total: 15,
collection: [{id: 'bb44db95-6fbd-4eed-a1ed-4d99bc91250f', amount: 15}]
},
fees: {
total: 5,
collection: [
{
id: 'a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93',
name: 'Eco Fee',
taxable: true,
attributes: {source: 'eco'},
tax: {total: 3, collection: [{amount: 3, attributes: {rate: '5.0', type: 'COUNTY'}}]},
updatedAt: '2024-06-13T16:50:00.682Z',
createdAt: '2024-06-13T16:50:00.682Z',
taxDetails: {
destinationAddress: 'c86f777b-1885-4ddf-961d-542ba80a69b8',
originAddress: 'c86f777b-1885-4ddf-961d-542ba80a69b8'
}
}
]
},
adjustments: {
total: 2,
collection: [
{
id: 'a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93',
reason: 'Price adjustment from customer representative.',
attributes: {source: 'CSR'},
updatedAt: '2024-06-13T16:50:00.682Z',
createdAt: '2024-06-13T16:50:00.682Z'
}
]
},
tax: {total: 3, collection: [{amount: 3, attributes: {rate: '5.0', type: 'COUNTY'}}]}
}
}
]
})
};
fetch('https://api.fabric.inc/v3/orchestrator/carts/{cartId}/items', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"id": "0e49199c-5849-4211-abe6-a97a3c4dcc56",
"attributes": {},
"configuration": {
"order": {
"validate": {}
},
"product": {
"cacheExpiry": 7776000,
"behaviors": {
"add": "REJECT",
"update": "WARN",
"get": "WARN",
"cacheExpiry": "WARN"
},
"maxQuantity": {
"limit": 100,
"behaviors": {
"add": "REJECT",
"update": "WARN",
"get": "WARN"
}
}
},
"inventory": {
"cacheExpiry": 7776000,
"behaviors": {
"add": "REJECT",
"update": "WARN",
"get": "WARN",
"cacheExpiry": "WARN"
},
"check": "SKU"
},
"tax": {
"cacheExpiry": 7776000,
"behaviors": {
"cacheExpiry": "WARN"
}
},
"promotions": {
"cacheExpiry": 86400,
"behaviors": {}
}
},
"customerContext": {
"id": "109840938",
"segments": [
{
"name": "membership",
"value": [
"gold",
"silver"
]
}
],
"attributes": {
"email": "test@gmail.com"
},
"sessionId": "3a5fd2d3-5c96-4e57-b069-7ff2a88c1119"
},
"status": "ACTIVE",
"state": [
{
"resource": "CART",
"resourceId": "c86f777b-1885-4ddf-961d-542ba80a69b8",
"key": "MISSING_PAYMENT_DETAILS",
"description": "No payment details have been added to this Cart"
}
],
"price": {
"total": 1570,
"subtotal": 1530,
"tax": 0,
"fulfillments": 40,
"discounts": 0,
"fees": 0,
"adjustments": 0
},
"promotions": {
"total": 0,
"collection": [
{
"id": "6626c179627d450008a5b202",
"title": "Cart Promotion Fixed Price",
"type": "QUANTITY",
"value": 10,
"attributes": {
"promotionStack": "HIGHEST"
}
}
]
},
"fees": {
"id": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
"name": "Eco Fee",
"price": {
"amount": 12.99
},
"taxable": true,
"attributes": {
"source": "eco"
},
"tax": {
"total": 3,
"collection": [
{
"amount": 3,
"attributes": {
"rate": "5.0",
"type": "COUNTY"
}
}
]
},
"updatedAt": "2024-06-13T16:50:00.682Z",
"createdAt": "2024-06-13T16:50:00.682Z",
"taxDetails": {
"destinationAddress": "c86f777b-1885-4ddf-961d-542ba80a69b8",
"originAddress": "c86f777b-1885-4ddf-961d-542ba80a69b8"
}
},
"adjustments": {
"total": 2,
"collection": [
{
"id": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
"price": {
"amount": 12.99
},
"reason": "Price adjustment from customer representative.",
"attributes": {
"source": "CSR"
},
"updatedAt": "2024-06-13T16:50:00.682Z",
"createdAt": "2024-06-13T16:50:00.682Z"
}
]
},
"addresses": {
"a8577d7f0d4d4b228e857b4a2e90dc93": {
"id": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
"name": {
"first": "John",
"last": "Doe"
},
"email": "john@test.com",
"phone": {
"number": "1234567890",
"type": "MOBILE"
},
"addressLine1": "123 Park Road",
"addressLine2": "<string>",
"addressLine3": "<string>",
"addressLine4": "<string>",
"city": "Santa Cruz",
"region": "California",
"country": "USA",
"postalCode": "12345",
"updatedAt": "2024-06-13T16:50:00.682Z",
"createdAt": "2024-06-13T16:50:00.682Z"
}
},
"lineItems": {
"total": 100,
"collection": [
{
"id": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
"sku": "SKU3",
"refId": "41",
"quantity": 10,
"priceListId": "10001",
"position": 1,
"price": {
"unit": 10,
"amount": 100
},
"fees": {
"total": 5,
"collection": [
{
"id": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
"name": "Eco Fee",
"price": {
"amount": 12.99
},
"taxable": true,
"attributes": {
"source": "eco"
},
"tax": {
"total": 3,
"collection": [
{
"amount": 3,
"attributes": {
"rate": "5.0",
"type": "COUNTY"
}
}
]
},
"updatedAt": "2024-06-13T16:50:00.682Z",
"createdAt": "2024-06-13T16:50:00.682Z",
"taxDetails": {
"destinationAddress": "c86f777b-1885-4ddf-961d-542ba80a69b8",
"originAddress": "c86f777b-1885-4ddf-961d-542ba80a69b8"
}
}
]
},
"promotions": {
"total": 2,
"collection": [
{
"id": "bb44db95-6fbd-4eed-a1ed-4d99bc91250f",
"amount": 15,
"quantity": 3,
"proration": {
"spread": [
{
"amount": 5,
"quantity": 3
}
]
}
}
]
},
"adjustments": {
"total": 2,
"collection": [
{
"id": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
"price": {
"amount": 12.99
},
"reason": "Price adjustment from customer representative.",
"attributes": {
"source": "CSR"
},
"updatedAt": "2024-06-13T16:50:00.682Z",
"createdAt": "2024-06-13T16:50:00.682Z"
}
]
},
"fulfillment": {
"id": "6d65755f-b1d9-4c9d-bb5b-118d317f8db4",
"price": {
"amount": 12.99
},
"inventory": {
"channels": {
"type": "WEB_PICKUP",
"locationNumber": "15",
"channelId": "12",
"networkCode": "shipToHome"
},
"type": "availableToPurchase"
},
"tax": {
"total": 3,
"collection": [
{
"amount": 3,
"attributes": {
"rate": "5.0",
"type": "COUNTY"
}
}
]
}
},
"attributes": {
"name": "item-custom"
},
"tax": {
"total": 3,
"collection": [
{
"amount": 3,
"attributes": {
"rate": "5.0",
"type": "COUNTY"
}
}
]
},
"taxCode": "10001",
"updatedAt": "2024-06-13T16:50:00.682Z",
"createdAt": "2024-06-13T16:50:00.682Z"
}
]
},
"summary": {
"totalItems": 1,
"totalUniqueItems": 1
},
"fulfillments": {
"d6229cdb0c5b4885b1b213b94d02488e": {
"id": "d6229cdb-0c5b-4885-b1b2-13b94d02488e",
"type": "SHIP_TO",
"refId": "398427903843",
"attributes": {
"source": "store"
},
"originAddress": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
"destinationAddress": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
"locationId": "CA",
"pickupPerson": {
"primary": {
"name": {
"first": "John",
"last": "Doe"
},
"email": "john@test.com",
"phone": {
"number": "1234567890",
"type": "MOBILE"
}
},
"secondary": [
{
"name": {
"first": "John",
"last": "Doe"
},
"email": "john@test.com",
"phone": {
"number": "1234567890",
"type": "MOBILE"
}
}
]
},
"price": {
"amount": 12.99
},
"promotions": {
"total": 15,
"collection": [
{
"id": "bb44db95-6fbd-4eed-a1ed-4d99bc91250f",
"amount": 15
}
]
},
"fees": {
"total": 5,
"collection": [
{
"id": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
"name": "Eco Fee",
"price": {
"amount": 12.99
},
"taxable": true,
"attributes": {
"source": "eco"
},
"tax": {
"total": 3,
"collection": [
{
"amount": 3,
"attributes": {
"rate": "5.0",
"type": "COUNTY"
}
}
]
},
"updatedAt": "2024-06-13T16:50:00.682Z",
"createdAt": "2024-06-13T16:50:00.682Z",
"taxDetails": {
"destinationAddress": "c86f777b-1885-4ddf-961d-542ba80a69b8",
"originAddress": "c86f777b-1885-4ddf-961d-542ba80a69b8"
}
}
]
},
"adjustments": {
"total": 2,
"collection": [
{
"id": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
"price": {
"amount": 12.99
},
"reason": "Price adjustment from customer representative.",
"attributes": {
"source": "CSR"
},
"updatedAt": "2024-06-13T16:50:00.682Z",
"createdAt": "2024-06-13T16:50:00.682Z"
}
]
},
"tax": {
"total": 3,
"collection": [
{
"amount": 3,
"attributes": {
"rate": "5.0",
"type": "COUNTY"
}
}
]
}
}
},
"coupons": [
{
"code": "VALID_COUPON",
"updatedAt": "2024-06-13T16:50:00.682Z"
}
],
"appliedCoupons": [
{
"code": "VALID_COUPON",
"updatedAt": "2024-06-13T16:50:00.682Z"
}
],
"notAppliedCoupons": [
{
"code": "VALID_COUPON",
"updatedAt": "2024-06-13T16:50:00.682Z"
}
],
"validations": {
"promotions": {
"updatedAt": "2024-06-13T16:50:00.682Z",
"appliedCoupons": [
"TEST_COUPON"
],
"refreshRequired": false
},
"lineItems": [
{
"sku": "SKU3",
"inventory": {
"channels": {
"networkCode": "ShipToHome"
},
"counters": {
"backOrder": 15,
"preOrder": 100
},
"updatedAt": "2024-06-13T16:50:00.682Z"
}
}
],
"product": {
"availableSkus": [
{
"sku": "SKU3",
"updatedAt": "2024-06-13T16:50:00.682Z",
"maxQuantity": 100
}
]
},
"tax": {
"updatedAt": "2024-06-13T16:50:00.682Z"
}
},
"payments": {
"authorized": 800,
"collection": [
{
"id": "6ef2067a-5d6b-4785-a090-96ea0078220d",
"provider": "verifone",
"processor": "stripe",
"method": "apple pay",
"methodType": "credit card",
"state": "PENDING",
"authorization": {
"amount": 8,
"expiry": "2024-06-13T16:50:00.682Z",
"verifier": {
"type": "TOKEN",
"key": "CH39082K439R0"
}
},
"billToAddress": "a8577d7f-0d4d-4b22-8e85-7b4a2e90dc93",
"cardDetails": {},
"attributes": {
"gift-card-name": "custom name"
}
}
]
},
"channelId": "12",
"currency": "USD",
"updatedAt": "2024-06-13T16:50:00.682Z",
"createdAt": "2024-06-13T16:50:00.682Z",
"suggestedProducts": [
{
"id": "12345",
"name": "Wireless Mouse",
"description": "A high-quality wireless mouse with ergonomic design.",
"price": 29.99
}
],
"promotionMessages": [
{
"message": "Buy one get one free",
"code": "BOGO"
}
],
"errors": [
{
"code": "ERR001",
"message": "Invalid input"
}
]
}{
"type": "UNPROCESSABLE_ORCHESTRATION",
"message": "4xx Error from orchestration dependency",
"errors": [
{
"type": "NOT_FOUND",
"message": "404 Not Found from POST https://api.fabric.inc/carts/326949f9-7c25-4983-9848-b2061abb217dl/items/batch",
"code": 404,
"source": "POST https://api.fabric.inc/carts/326949f9-7c25-4983-9848-b2061abb217dl/items/batch",
"details": {
"type": "CART_NOT_FOUND",
"message": "Cart not found",
"errors": []
}
}
]
}Add items
Add items to the corresponding cart.
The Cart ID from the Create cart endpoint is used in the path parameter.
Authorizations
Include the Bearer<token> header where the <token> is the authentication token generated from the Getting Started with fabric APIs process.
Headers
A header used by fabric to identify the tenant making the request. You must include tenant id in the authentication header for an API request to access any of fabric’s endpoints. You can retrieve the tenant id , which is also called account id, from Copilot. This header is required.
Unique request ID for tracking.
x-fabric-channel-id identifies the sales channel where the API request is being made; primarily for multichannel use cases. The channel ids are 12 corresponding to US and 13 corresponding to Canada. The default channel id is 12. This field is required.
Path Parameters
The 24-character system-generated Cart ID. This ID is generated using the Create cart endpoint.
Body
An array containing item objects with their information. One or more items can be added to the cart by passing multiple item objects into the array of the request body.
Show child attributes
Show child attributes
Response
Items added to the cart successfully
The unique identifier of the cart that was passed in the parameter.
"0e49199c-5849-4211-abe6-a97a3c4dcc56"
Custom attributes used to describe the cart, such as a wishlist cart.
Show child attributes
Show child attributes
Cart configurations determine the behavior within the cart.
Show child attributes
Show child attributes
Customer context object containing customer information.
Show child attributes
Show child attributes
The cart status indicates whether the cart is active or deleted.
ACTIVE, SOFT_DELETE "ACTIVE"
The resource state is stored in an array that holds information about the current status of the cart.
Show child attributes
Show child attributes
The sum of the total amount of the cart.
Show child attributes
Show child attributes
A collection of promotions applied to the cart.
Show child attributes
Show child attributes
A collection of fees associated with the cart.
Show child attributes
Show child attributes
A collection of adjustments made to the cart.
Show child attributes
Show child attributes
A map of addresses added to the cart.
Show child attributes
Show child attributes
A collection of items in the cart.
Show child attributes
Show child attributes
A summary of items in the cart.
Show child attributes
Show child attributes
A map of fulfillments added to the cart.
Show child attributes
Show child attributes
An array containing all coupons added to the cart.
Show child attributes
Show child attributes
An array containing all coupons applied to the cart.
Show child attributes
Show child attributes
An array containing any coupons that were ineligible and not applied to the cart.
Show child attributes
Show child attributes
Show child attributes
Show child attributes
An object containing a collection of payments added to the cart.
Show child attributes
Show child attributes
Channel ID
"12"
The currency that the cart will use when an order is created.
"USD"
The date and time in UTC when the cart was last updated.
"2024-06-13T16:50:00.682Z"
The date and time when a cart was created.
"2024-06-13T16:50:00.682Z"
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Was this page helpful?
